import java.util.ArrayList;

public class BinaryTree {
	private BTNode root; 
	
	public void setRoot(BTNode root) {
		this.root = root;
	}
	
	public BinaryTree() {
		
	}
	
	public void addToLeft(BTNode n, String element) {
		if(n.getLeft() != null) {
			throw new IllegalArgumentException("Left is already there");
		}
		n.setLeft(new BTNode(element));
	}
	
	public void addToRight(BTNode n, String element) {
		if(n.getRight() != null) {
			throw new IllegalArgumentException("Right is already there");
		}
		n.setRight(new BTNode(element));
	}
	
	public int size() {
		return sizeHelper(root);
	}
	
	private int sizeHelper(BTNode root) {
		if(root == null) {
			return 0;
		}
		else {
			return 1 + sizeHelper(root.getLeft()) + sizeHelper(root.getRight());
		}
	}
	
	public boolean has(String e) {
		return hasHelper(root, e);
	}
	
	private boolean hasHelper(BTNode root, String e) {
		if(root == null) {
			return false;
		}
		else {
			return 
				root.getElement().equals(e) 
				||
				hasHelper(root.getLeft(), e) 
				||
				hasHelper(root.getRight(), e);
		}
	}
	
	public ArrayList<String> inroder() {
		ArrayList<String> list = new ArrayList<>();
		inorderHelper(root, list);
		return list;
	}
	
	private void inorderHelper(BTNode root, ArrayList<String> list) {
		if(root != null) {
			inorderHelper(root.getLeft(), list);
			list.add(root.getElement());
			inorderHelper(root.getRight(), list);
		}
	}
	
	public ArrayList<String> preorder() {
		ArrayList<String> list = new ArrayList<>();
		preorderHelper(root, list);
		return list;
	}
	
	private void preorderHelper(BTNode root, ArrayList<String> list) {
		if(root != null) {
			list.add(root.getElement());
			preorderHelper(root.getLeft(), list);
			preorderHelper(root.getRight(), list);
		}
	}
	
	public ArrayList<String> postorder() {
		ArrayList<String> list = new ArrayList<>();
		postorderHelper(root, list);
		return list;
	}
	
	private void postorderHelper(BTNode root, ArrayList<String> list) {
		if(root != null) {
			postorderHelper(root.getLeft(), list);
			postorderHelper(root.getRight(), list);
			list.add(root.getElement());
		}
	}
}	
