import static org.junit.Assert.*;

import java.util.ArrayList;

import org.junit.Test;

public class TestBT {
	@Test
	public void testBTSize() {
		BinaryTree bt = new BinaryTree();
		assertEquals(0, bt.size());
		
		BTNode root = new BTNode("D");
		bt.setRoot(root);
		assertEquals(1, bt.size());
		
		bt.addToLeft(root, "B");
		bt.addToRight(root, "F");
		bt.addToLeft(root.getLeft(), "A");
		bt.addToRight(root.getLeft(), "C");
		bt.addToLeft(root.getRight(), "E");
		bt.addToRight(root.getRight(), "G");
		assertEquals(7, bt.size());
	} 
	
	@Test
	public void testBTMembership() {
		BinaryTree bt = new BinaryTree();
		assertFalse(bt.has("D"));
		
		BTNode root = new BTNode("D");
		bt.setRoot(root);
		assertTrue(bt.has("D"));
		assertFalse(bt.has("A"));
		
		bt.addToLeft(root, "B");
		bt.addToRight(root, "F");
		bt.addToLeft(root.getLeft(), "A");
		bt.addToRight(root.getLeft(), "C");
		bt.addToLeft(root.getRight(), "E");
		bt.addToRight(root.getRight(), "G");
		assertTrue(bt.has("A"));
		assertTrue(bt.has("B"));
		assertTrue(bt.has("C"));
		assertTrue(bt.has("D"));
		assertTrue(bt.has("E"));
		assertTrue(bt.has("F"));
		assertTrue(bt.has("G"));
		assertFalse(bt.has("H"));
		assertFalse(bt.has("I"));
	}
	
	@Test
	public void testBT_inorder() {
		BinaryTree bt = new BinaryTree();
		BTNode root = new BTNode("D");
		bt.setRoot(root);
		bt.addToLeft(root, "B");
		bt.addToRight(root, "F");
		bt.addToLeft(root.getLeft(), "A");
		bt.addToRight(root.getLeft(), "C");
		bt.addToLeft(root.getRight(), "E");
		bt.addToRight(root.getRight(), "G");
		ArrayList<String> list = bt.inroder();
		assertEquals(list.get(0), "A");
		assertEquals(list.get(1), "B");
		assertEquals(list.get(2), "C");
		assertEquals(list.get(3), "D");
		assertEquals(list.get(4), "E");
		assertEquals(list.get(5), "F");
		assertEquals(list.get(6), "G");
	}
	
	@Test
	public void testBT_preorder() {
		BinaryTree bt = new BinaryTree();
		BTNode root = new BTNode("D");
		bt.setRoot(root);
		bt.addToLeft(root, "B");
		bt.addToRight(root, "F");
		bt.addToLeft(root.getLeft(), "A");
		bt.addToRight(root.getLeft(), "C");
		bt.addToLeft(root.getRight(), "E");
		bt.addToRight(root.getRight(), "G");
		ArrayList<String> list = bt.preorder();
		assertEquals(list.get(0), "D");
		assertEquals(list.get(1), "B");
		assertEquals(list.get(2), "A");
		assertEquals(list.get(3), "C");
		assertEquals(list.get(4), "F");
		assertEquals(list.get(5), "E");
		assertEquals(list.get(6), "G");
	}
	
	public void testBT_postorder() {
		BinaryTree bt = new BinaryTree();
		BTNode root = new BTNode("D");
		bt.setRoot(root);
		bt.addToLeft(root, "B");
		bt.addToRight(root, "F");
		bt.addToLeft(root.getLeft(), "A");
		bt.addToRight(root.getLeft(), "C");
		bt.addToLeft(root.getRight(), "E");
		bt.addToRight(root.getRight(), "G");
		ArrayList<String> list = bt.preorder();
		assertEquals(list.get(0), "A");
		assertEquals(list.get(1), "C");
		assertEquals(list.get(2), "B");
		assertEquals(list.get(3), "E");
		assertEquals(list.get(4), "G");
		assertEquals(list.get(5), "F");
		assertEquals(list.get(6), "D");
	}
}
